\documentclass[a4paper, trou]{./tpl/ddpoly-en}
\usepackage{dirtree}
\usepackage{wasysym}
\usepackage{mathtools}
\usepackage{enumitem}
\setlist{nolistsep}

\input{macro}
\input{tpl/listing-config}

  
\graphicspath{{tpl/}{img/}}
\ddmodulename{Computer Science}
\ddmodulenumber{Tutorial Minidem}
\ddauthor{D. André}
\dduniv{Ensil-Ensci}
\ddimg{\begin{center}\includegraphics[width=6cm]{img/arduino-logo}\end{center}}
\rien



\begin{document}
\renewcommand{\labelitemi}{$\bullet$}
\lstset{language=granCpp,style=granCpp}  
\lstset{language=granPython,style=granPython}  




\newdemexo{10}{Applying Forces}

\noindent The goal of this tutorial is to show you how to apply loads by applying forces to certain grains. If you look at the video from the previous tutorial
(\dltutodem{09}{tuto-09\_correction.mp4}), you will see that this type of loading (by imposing displacements) is not realistic, as the blue grains are compressed beyond reasonable limits. In this case, it is better to apply forces rather than displacements. Indeed, the loading will "stop" by itself once equilibrium is reached.

\vspace{0.5cm}

\begin{task}
  Download the module \dldem{minidem.py} and the script
  \dltutodem{10}{tuto-10\_exercice.py}. Run the script
  \dltutodem{10}{tuto-10\_exercice.py}.
\end{task}

\begin{info}
At this point, you should obtain a simulation similar to the video \dltutodem{10}{tuto-10\_exercice.mp4}.
\end{info}

\begin{info}
  The function \texttt{add\_extern\_force()} applies a vertical force of \texttt{10e4} N to all gray grains. To do this, the function:
  \begin{enumerate}
  \item adds up all the vertical forces (including the imposed force) on the gray grains, and then,
  \item distributes this force uniformly across each gray grain.
  \end{enumerate}
  This "trick" allows you to consider all the gray grains as a single solid.
\end{info}


\begin{task}
  Modify the \texttt{main} block to "fill" the following lists with the appropriate sets of grains:
  \begin{itemize}
  \item \texttt{gray\_grain\_list\_top}
  \item \texttt{gray\_grain\_list\_left}
  \item \texttt{gray\_grain\_list\_right}
  \end{itemize}
\end{task}

\begin{task}
  Modify the function \texttt{apply\_boundary\_condition()} to compress the blue grains as shown in the video \dltutodem{10}{tuto-10\_correction.mp4}.
\end{task}

\begin{info}
  At this point, you should obtain a simulation similar to the video \dltutodem{10}{tuto-10\_correction.mp4}.
\end{info}

\end{document}
